// Display Panel for SpXZeigR
// $Author: Jeffrey J Weimer $
// This works with SpXZeigR 4.x
// Revision History: $Revision: 1045 $ on $Date: 2009-04-29 18:49:50 -0500 (Wed, 29 Apr 2009) $

#pragma rtGlobals=1
#pragma IgorVersion=6.03
#pragma version=4.3

#pragma ModuleName=SpXZeigRPanel

// REQUIRED External Packages

#include "udFLStandardPanel"

#include "SpXZeigRGraph"

Static Constant PTrim=10

// show the panel

Static Function ShowSpXZeigRPanel()
	
	udFLStandardPanel#ShowPanel(1)
	CreateSpXZeigRDisplayTab()
	return 0
end

Static Function CreateSpXZeigRDisplayTab()

	SVAR dff = root:Packages:SpXZeigR:DisplayPanel:displayfromfolder
	SVAR dwc = root:Packages:SpXZeigR:DisplayPanel:displaywildcard
	SVAR dfGraphMode = root:Packages:SpXZeigR:Graphs:GraphModes:defaultGraphMode
	SVAR dfSpectrumType = root:Packages:SpXZeigR:Graphs:SpectrumTypes:defaultSpectrumType
	SVAR dfTraceStyle = root:Packages:SpXZeigR:Graphs:TraceStyles:defaultTraceStyle
	NVAR dlnked = root:Packages:SpXZeigR:DisplayPanel:displaylinked
	
	variable dfSTn, dfGMn, dfTSn, dfdffn

	TabControl tb, tabLabel(1)=xzdis00, value=1
	
	dfGMn =  WhichListItem(dfGraphMode,GraphModes())+1
	dfSTn = WhichListItem(dfSpectrumType,SpectrumTypes())+1
	dfTSn = WhichListItem(dfTraceStyle,TraceStyles())+1

	// Display Tab
	// =====

	// Folder List
	
	if (strlen(dff)==0)
		dfdffn = 3
	else
		dfdffn = WhichListItem(dff,SpXZeigRPanel#FolderList(1))+1
	endif
	PopupMenu flist_tb1,pos={PTrim,30},size={122,20},title=xzdis00a,fSize=12
	PopupMenu flist_tb1, mode=dfdffn,popvalue=dff, value=#"SpXZeigRPanel#FolderList(1)", proc=SpXZeigRPanel#ChangeDisplayFromFolder

	// File List

	PopupMenu spectrum_tb1,pos={PTrim,65},size={87,20},title=xzdis00b,fSize=12
	dfdffn = WhichListItem(dff,SpXZeigRPanel#FolderList(1))+1
	PopupMenu spectrum_tb1,mode=1,value=#"SpXZeigRPanel#SpectraList(0)", proc=SpXZeigRPanel#SelectDisplayTraces
	
	CheckBox xLink_tb1,pos={100,68}, size={60,20}, title="Linked", value=dlnked, proc=SpXZeigRPanel#SetShowLinked
	
	CheckBox xnegwc_tb1,pos={185,68}, size={60,20}, title="(-)", value=0

	// Wave Note
	
	Button wavenote_tb1, pos={200,65}, size={20,20}, title="?", fSize=10, proc=SpXZeigRPanel#ShowWaveNote
	
	// Wildcard Input

	SetVariable wildcard_tb1,pos={PTrim,90},size={185,17},title=xzdis00c,fSize=12
	SetVariable wildcard_tb1,value=dwc, proc=SpXZeigRPanel#ValidateWildCard
			
	// Multitrace Control

	PopupMenu multitrace_tb1,pos={PTrim,120},size={157,20},title=xzdis00d,fSize=12
	PopupMenu multitrace_tb1,mode=1,popvalue="On New",value= #"SpXZeigRPanel#MultiTraceMenu()"

	// Spectrum Type
	
	PopupMenu type_tb1,pos={PTrim,165},size={142,20},title=xzdis00e,fSize=12
	PopupMenu type_tb1,mode=dfSTn,value=#"SpXZeigRPanel#SpectrumTypes()", popValue=dfSpectrumType

	// Plot Mode
	
	PopupMenu plotmode_tb1,pos={PTrim,195},size={108,20},title=xzdis00f,fSize=12
	PopupMenu plotmode_tb1,mode=dfGMn,value=#"SpXZeigRPanel#GraphModes()", popValue=dfGraphMode

	// Trace Style
	
	PopupMenu tracestyle_tb1,pos={PTrim,225},size={108,20},title=xzdis00k,fSize=12
	PopupMenu tracestyle_tb1,mode=dfTSn,value=#"SpXZeigRPanel#TraceStyles()", popValue=dfTraceStyle

	// Loader
	
	CheckBox xloader_tb1,pos={PTrim,145},size={87,20},title=xzdis00g
	CheckBox xloader_tb1,value=0, proc=SpXZeigRPanel#CheckLoaderModes

	// Do Both Button
	
	Button doboth,pos={PTrim+120,285},size={100,20},title=xzdis00h, disable=1, proc=SpXZeigRPanel#DoBoth
	Button doboth, font="Arial",fSize=12, fColor=(49151,49151,65535)

	udFLStandardPanel#PanelFillTab(1)
end

Function udFLPanelSetTab1(how)
	variable how
	
	if (how==1)
	
	// create things

		Button tb_doit, title=xzdis00i, userData="SpXZeigRPanel#DisplayData()"
		ControlInfo flist_tb1
		if (V_value<3)
			PopupMenu spectrum_tb1 disable = 1
			PopupMenu multitrace_tb1 disable = 0
			SetVariable wildcard_tb1 disable = 1
			CheckBox xloader_tb1 disable=0	
			CheckBox xnegwc_tb1,disable=1
			Button wavenote_tb1 disable=1
			Button tb_doit disable = 1
			Button doboth disable=0
			Checkbox xLink_tb1 disable=1
		else
			ControlInfo spectrum_tb1
			Button tb_doit disable=(cmpstr(S_value,"(no spectra)")==0)
			Checkbox xLink_tb1 disable=(cmpstr(S_value,"(no spectra)")==0)
			PopupMenu type_tb1 disable=(cmpstr(S_value,"(no spectra)")==0)
			PopupMenu plotmode_tb1 disable=(cmpstr(S_value,"(no spectra)")==0)
			Button wavenote_tb1 disable=(V_value<3)
			SetVariable wildcard_tb1 disable=(V_value!=2)
			CheckBox xnegwc_tb1 disable=(V_value!=2)
			PopupMenu multitrace_tb1 disable=((V_value>2)||(cmpstr(S_value,"(no spectra)")==0))
			CheckBox xloader_tb1 disable=1
			Button doboth disable=1
		endif
	else
	
	// possibly remove things
	
		ControlInfo flist_tb1
		if ((V_flag>0)&& (V_value<3))
			Button tb_doit disable = 1
			Button doboth disable=0
		endif
	
	endif
	
	return 0
end

// load and display data

Static Function DoBoth(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	SVAR lowl = root:Packages:StandardizedFileLoader:listofwavesloaded
	SVAR ltf =  root:Packages:StandardizedFileLoader:loadtofolder
	SVAR wtd = root:Packages:SpXZeigR:DisplayPanel:displaywavelist
	SVAR dff = root:Packages:SpXZeigR:DisplayPanel:displayfromfolder
	NVAR dlnked = root:Packages:SpXZeigR:DisplayPanel:displaylinked
	
	STRUCT udFLStandardStructure udFL
	variable cm
	string theFldr = "root:"
	
	switch(ba.eventCode)
		case 2:
			ControlInfo tb_closeme
			cm = V_value
			CheckBox tb_closeme value=0
			ba.UserData="Load"
			udFLStandardPanel#DoIt(ba)
			if (strlen(lowl)==0)
				DoAlert 0, xzStr07
				break
			endif
			if (cmpstr("root",ltf)!=0)
				theFldr += ltf
			endif
			wtd=LinkDisplay#LinkList(theFldr,dlnked-1,WavesList=lowl)
			dff = ltf
			CheckBox tb_closeme value=cm
			ba.UserData="SpXZeigRPanel#DisplayData()"
			udFLStandardPanel#DoIt(ba)
			break
	endswitch
	return 0
end

Static Function DisplayData()

	SVAR wtd = root:Packages:SpXZeigR:DisplayPanel:displaywavelist
	SVAR dwc = root:Packages:SpXZeigR:DisplayPanel:displaywildcard
	SVAR dfGraphMode = root:Packages:SpXZeigR:Graphs:GraphModes:defaultGraphMode
	SVAR dfTraceStyle = root:Packages:SpXZeigR:Graphs:TraceStyles:defaultTraceStyle
	SVAR dfSpectrumType = root:Packages:SpXZeigR:Graphs:SpectrumTypes:defaultSpectrumType
	NVAR dmt = root:Packages:SpXZeigR:DisplayPanel:displaymultitrace

	if (strlen(wtd)==0)
		ControlInfo spectrum_tb1
		strswitch(S_Value)
			case "(no spectra)":
				DoAlert 0, xzdia00a
				return 0
				break
			case "All":
				wtd = SpectraList(1)
				break
			case "Match WildCard":
				wtd = ListMatch(SpectraList(1),dwc)
				ControlInfo xnegwc_tb1
				if (V_value)
					wtd = RemoveFromList(wtd,SpectraList(1))
				endif
				break
			default:
				wtd = S_Value + ";"
		endswitch		
		if (strlen(wtd)==0)
			DoAlert 0, xzdia00a
			return 0
		endif
	endif
	
	ControlInfo multitrace_tb1
	dmt = V_value
	ControlInfo plotmode_tb1
	dfGraphMode = S_value
	ControlInfo tracestyle_tb1
	dfTraceStyle = S_value
	ControlInfo type_tb1
	dfSpectrumType = S_value
	
	SpXZeigRGraph#DisplaySpectra()
	wtd =""				
	return 0

end

// change things when display folder is changed

Static Function ChangeDisplayFromFolder(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa

	SVAR dff = root:Packages:SpXZeigR:DisplayPanel:displayfromfolder
	SVAR lff = root:Packages:SpXZeigR:DisplayPanel:loadtofolder
	
	switch( pa.eventCode )
		case 2:
		
			// display from load
			
			if (pa.popNum ==1)
				PopupMenu flist_tb1 mode = 1
				PopupMenu spectrum_tb1 disable=1
				PopupMenu multitrace_tb1 disable=0
				PopupMenu type_tb1 disable=0
				PopupMenu plotmode_tb1 disable=0
				Button tb_doit disable=1
				Button doboth disable=0
				Checkbox xLink_tb1 disable=1
				CheckBox xloader_tb1 disable=0
				CheckBox xnegwc_tb1,disable=1
				SetVariable wildcard_tb1 disable = 1
				Button wavenote_tb1 disable=1
				dff = "root"
				break
			endif
			dff = pa.popStr
			PopupMenu spectrum_tb1 mode=1, disable=0
			ControlInfo spectrum_tb1
			PopupMenu multitrace_tb1 disable=(cmpstr(S_value,"All")!=0)
			PopupMenu type_tb1 disable=(cmpstr(S_value,"(no spectra)")==0)
			PopupMenu plotmode_tb1 disable=(cmpstr(S_value,"(no spectra)")==0)
			Button tb_doit disable=(cmpstr(S_value,"(no spectra)")==0)
			Checkbox xLink_tb1 disable=(cmpstr(S_value,"(no spectra)")==0)
			SetVariable wildcard_tb1 disable=(cmpstr(S_value,"Match WildCard")!=0)
			CheckBox xnegwc_tb1,disable=(cmpstr(S_value,"Match WildCard")!=0)
			Button wavenote_tb1 disable=(V_value<2)
			Button doboth disable=1
			CheckBox xloader_tb1 disable=1
			CheckBox xloader_tb1 value=0
			break
	endswitch

	return 0
End

// change things when file list is changed

Static Function SelectDisplayTraces(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa
	
//	SVAR dff = root:Packages:SpXZeigR:DisplayPanel:displayfromfolder
		
	switch( pa.eventCode )
		case 2:
			Button wavenote_tb1 disable=1
			CheckBox xnegwc_tb1 disable=1
			CheckBox xLink_tb1, disable=1
			SetVariable wildcard_tb1 disable=1
			PopupMenu multitrace_tb1,title=xzdis00d
			switch(pa.popNum)
				case 1:
					CheckBox xLink_tb1, disable=0
					break
				case 2:
					SetVariable wildcard_tb1 disable=0	
					CheckBox xnegwc_tb1 disable=0
					break
				case 3:
					PopupMenu spectrum_tb1 mode=1
					break
				default:
					PopupMenu multitrace_tb1, title=xzdis00j
					Button wavenote_tb1 disable=0
			endswitch
			break
	endswitch

	return 0
End

// validate wild card

Static Function ValidateWildCard(sv) : SetVariableControl
	STRUCT WMSetVariableAction &sv

	SVAR dwc = root:Packages:SpXZeigR:DisplayPanel:displaywildcard
	
	variable trn
	
	switch(sv.eventCode)
		case 2:
			if ((strsearch(sv.sval,":",0)>0)||(strsearch(sv.sval," ",0)>0))
				dwc = "INVALID : or Spaces!"
				ControlUpdate wildcard_tb1
				trn = ticks
				do
				while((ticks-trn)<90)
				dwc=""
				SetVariable wildcard_tb1 activate
			endif
			break	
	endswitch
	
	return 0
End

// show wave note

Static Function ShowWaveNote(bc) : ButtonControl
	STRUCT WMButtonAction &bc
	
	string wnote, wname, fname, wnotem,  theExt = "\[(.+)\]", theStr

	wnotem = "Wave Note for "
	
	switch(bc.eventCode)
		case 2:
			ControlInfo flist_tb1
			if (cmpstr(S_value,"root")==0)
				fname = "root:"
			else
				fname = "root:" + S_value + ":"
			endif
			wnotem += fname
			ControlInfo spectrum_tb1
			SplitString/E=(theExt) S_value, theStr
			if (strlen(theStr)==0)
				wname = fname + S_value
			else
				wname = fname + theStr
			endif
			wnote = note($wname)
			if (strlen(wnote)==0)
				wnote = "NO NOTES EXIST FOR THIS DATA"
			endif
			
			// kill prior notebook
			
			if (strlen(WinList("xzWaveNote","","WIN:16"))!=0)
				KillWindow xzWaveNote
			endif
			
			NewNoteBook/F=0/K=1/N=xzWaveNote
			Notebook xzWaveNote status={wnotem,0}
			Notebook xzWaveNote text=wnote	
			ScreenSizer#MoveFrontWindow(50,10,80,30)
			
			break
	endswitch
	
	return 0
end

Static Function/S FolderList(how)
	variable how

	string dflist, objName=""
	variable ic = 0

	if (how==0)
		dflist = "Create New;\\M1(-;root;"
	else
		dflist = "From Load;\\M1(-;root;"
	endif
	
	do
		objName = GetIndexedObjName("root:", 4, ic)
		if (strlen(objName) == 0)
			break
		else
			if (cmpstr(objName,"Packages")!=0)
				dflist += objName + ";"
			endif
		endif
		ic += 1
	while(1)
	
	return dflist
end

Static Function/S SpectraList(how)
	variable how

	SVAR dff = root:Packages:SpXZeigR:DisplayPanel:displayfromfolder
	NVAR dlnked = root:Packages:SpXZeigR:DisplayPanel:displaylinked
	
	string flist="", slist="", theFldr="root:"
	variable lhow=0
	
	if (cmpstr(dff,"root")!=0)
		theFldr += dff
	endif
	
	if (how==0)
		flist = "All;Match WildCard;-;"
		if (dlnked)
			lhow = 1
		else
			lhow = -1
		endif
	else
		if (dlnked)
			lhow = 0
		else
			lhow = -1
		endif
	endif
	
	slist = SortList(LinkDisplay#LinkList(theFldr,lhow),";",16)
	
	return (flist + slist)
	
end

Static Function/S GraphModes()

	string sloc = "root:Packages:SpXZeigR:Graphs:GraphModes"
	
	return ListDir(sloc)
end

Static Function/S SpectrumTypes()

	string sloc = "root:Packages:SpXZeigR:Graphs:SpectrumTypes"
	
	return ListDir(sloc)

end

Static Function/S TraceStyles()

	string sloc = "root:Packages:SpXZeigR:Graphs:TraceStyles"
	
	string slist = "", objName =""
	variable ic = 0
	do
		objName = GetIndexedObjName(sloc,3,ic)
		if (strlen(objName)==0)
			break
		endif
		if(stringmatch(objName, "default*")==0)
			slist += objName + ";"
		endif
		ic+=1
	while(1)
	
//	objName = ReplaceString("SpXTS",FunctionList("SpXTS_*",";",""),"")

	return (slist)

end

Static Function/S ListDir(sloc)
	string sloc
	
	string slist = "", objName=""
	variable ic = 0
	do
		objName = GetIndexedObjName(sloc,4,ic)
		if (strlen(objName)==0)
			break
		endif
		slist += objName + ";"
		ic+=1
	while(1)
	
	return slist
	
end

Static Function/S MultiTraceMenu()
	
	string mtm ="On New;"
	
	ControlInfo spectrum_tb1
	if (strlen(WinList("*",";","WIN:1"))==0)
		if (V_value<3)
			mtm += "\\M1(On TopMost;Separate;"
		else
			mtm += "\\M1(On TopMost;\\M1(Separate;"
		endif
	else
		if (V_value<3)
			mtm += "On TopMost;Separate;"
		else
			mtm += "On TopMost;\\M1(Separate;"
		endif
	endif
	return mtm
end

Static Function CheckLoaderModes(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	switch( cba.eventCode )
		case 2: // mouse up
			PopupMenu type_tb1, disable=cba.checked
			break
	endswitch

	return 0
End

Static Function SetShowLinked(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	NVAR dlnked = root:Packages:SpXZeigR:DisplayPanel:displaylinked

	switch( cba.eventCode )
		case 2: // mouse up
			dlnked=cba.checked
			break
	endswitch

	return 0
End
