<?xml version="1.0" encoding="UTF-8"?>
<?igorpro version="1.04"?>

<!--
Revision History: $Revision: 852 $ on $Date: 2008-07-17 14:18:12 -0500 (Thu, 17 Jul 2008) $

Do NOT change this file!!
-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:strip-space elements="*"/>
	<xsl:output method="html" indent="yes"/>

<xsl:template match="/">
	<body>
	<xsl:apply-templates/>
	</body>
</xsl:template>

<xsl:template match="*">
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="text()">
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="paradigms">
       [code]
       NewDataFolder/O/S root:Packages:SpXZeigR:Paradigms
       [/code]
       <xsl:for-each select="paradigm">
       <xsl:variable name="type" select="name"/>
      [code]
       NewDataFolder/O/S root:Packages:SpXZeigR:Paradigms:<xsl:value-of select="$type" />
       [/code]
	<ol id="feedbacks"><li id="verbose"><xsl:value-of select="feedbacks/verbose"/></li></ol>
	<ol id="screen">
	<li id="left"><xsl:value-of select="screen/left"/></li>
	<li id="top"><xsl:value-of select="screen/top"/></li>
	<li id="right"><xsl:value-of select="screen/right"/></li>
	<li id="bottom"><xsl:value-of select="screen/bottom"/></li>
	</ol>
	<ol id="paths">
	<li id="data"><xsl:value-of select="paths/data"/></li>
	<li id="storage"><xsl:value-of select="paths/storage"/></li>
	</ol>
	<ol id="fileloaders">
	<xsl:for-each select="fileloaders/loader">
	 <li id="loader"><xsl:value-of select="."/></li>
	</xsl:for-each>
	</ol>
	</xsl:for-each>
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="defaultparadigm">
       [code]
       NewDataFolder/O/S root:Packages:SpXZeigR:Paradigms
       [/code]
	<DIV id="string">
	<p id="defaultParadigm"><xsl:value-of select="."/></p>
	</DIV>
</xsl:template>

<xsl:template match="spectra">
       [code]
       NewDataFolder/O/S root:Packages:SpXZeigR:Graphs:SpectrumTypes
       [/code]
       <xsl:for-each select="spectrum">
       <xsl:variable name="tech" select="name"/>
      [code]
       NewDataFolder/O/S root:Packages:SpXZeigR:Graphs:SpectrumTypes:<xsl:value-of select="$tech" />
       [/code]
	<ol id="title"><li id="text"><xsl:value-of select="title/text"/></li></ol>
	<ol id="labels">
	<li id="left"><xsl:value-of select="axes/left/label"/></li>
	<li id="bottom"><xsl:value-of select="axes/bottom/label"/></li>
	</ol>
	<ol id="scalings">
	<li id="left"><xsl:value-of select="axes/left/scaling"/></li>
	<li id="bottom"><xsl:value-of select="axes/bottom/scaling"/></li>
	</ol>
	<ol id="units">
	<li id="left"><xsl:value-of select="axes/left/units"/></li>
	<li id="bottom"><xsl:value-of select="axes/bottom/units"/></li>
	</ol>
	</xsl:for-each>
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="defaultspectrumtype">
       [code]
       NewDataFolder/O/S root:Packages:SpXZeigR:Graphs:SpectrumTypes
       [/code]
	<DIV id="string">
	<p id="defaultSpectrumType"><xsl:value-of select="."/></p>
	</DIV>
</xsl:template>
   
<xsl:template match="graphmodes">
       [code]
       NewDataFolder/O/S root:Packages:SpXZeigR:Graphs:GraphModes
       [/code]
     <xsl:for-each select="graphmode">
       <xsl:variable name="mode" select="name"/>
       [code]
       NewDataFolder/O/S root:Packages:SpXZeigR:Graphs:GraphModes:<xsl:value-of select="$mode" />
       [/code]
	<ol id="textdefaults">
	<li id="font"><xsl:value-of select="textdefaults/font"/></li>
	<li id="UnitEnvelope"><xsl:value-of select="textdefaults/UnitEnvelope"/></li>
	<li id="AxesLabelSizes"><xsl:value-of select="textdefaults/AxesLabelSizes"/></li>
	<li id="AnnotationSizes"><xsl:value-of select="textdefaults/AnnotationSizes"/></li>
	<li id="TitleSize"><xsl:value-of select="textdefaults/TitleSize"/></li>
	</ol>
	[code]
	SetDataFolder root:Packages:SpXZeigR:Graphs:GraphModes:<xsl:value-of select="$mode" />
	NewDataFolder/O/S axes
	[/code]
	<ol id="left">
	 <li id="log"><xsl:value-of select="axes/left/log"/></li>
	 <li id="mirror"><xsl:value-of select="axes/left/mirror"/></li>
	 <li id="axOffset"><xsl:value-of select="axes/left/offset"/></li>
	 <li id="axThick"><xsl:value-of select="axes/left/thickness"/></li>
	 <li id="fStyle"><xsl:value-of select="axes/left/font/style"/></li>
	 <li id="nticks"><xsl:value-of select="axes/left/ticks/major"/></li>
	 <li id="minor"><xsl:value-of select="axes/left/ticks/minor"/></li>
	</ol>
 	<ol id="bottom">
	 <li id="log"><xsl:value-of select="axes/bottom/log"/></li>
	 <li id="mirror"><xsl:value-of select="axes/bottom/mirror"/></li>
	 <li id="axOffset"><xsl:value-of select="axes/bottom/offset"/></li>
	 <li id="axThick"><xsl:value-of select="axes/bottom/thickness"/></li>
	 <li id="fStyle"><xsl:value-of select="axes/bottom/font/style"/></li>
	 <li id="nticks"><xsl:value-of select="axes/bottom/ticks/major"/></li>
	 <li id="minor"><xsl:value-of select="axes/bottom/ticks/minor"/></li>
	 </ol>
	[code]
	SetDataFolder root:Packages:SpXZeigR:Graphs:GraphModes:<xsl:value-of select="$mode" />
	NewDataFolder/O/S grids
	[/code]
	<ol id="left">
	 <li id="mode"><xsl:value-of select="grid/left/mode"/></li>
	 <li id="Style"><xsl:value-of select="grid/left/style"/></li>
	 <li id="Hair"><xsl:value-of select="grid/left/thickness"/></li>
	 <li id="RGB"><xsl:value-of select="grid/left/color"/></li>
	</ol>
 	<ol id="bottom">
	 <li id="mode"><xsl:value-of select="grid/bottom/mode"/></li>
	 <li id="Style"><xsl:value-of select="grid/bottom/style"/></li>
	 <li id="Hair"><xsl:value-of select="grid/bottom/thickness"/></li>
	 <li id="RGB"><xsl:value-of select="grid/bottom/color"/></li>
	</ol>
     </xsl:for-each>
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="defaultgraphmode">
       [code]
       NewDataFolder/O/S root:Packages:SpXZeigR:Graphs:GraphModes
       [/code]
	<DIV id="string">
	<p id="defaultGraphMode"><xsl:value-of select="."/></p>
	</DIV>
</xsl:template>

<xsl:template match="tracestyles">
       [code]
       NewDataFolder/O/S root:Packages:SpXZeigR:Graphs:TraceStyles
       [/code]
     <xsl:for-each select="tracestyle">
       <xsl:variable name="trace" select="name"/>
	<ol id="{$trace}">
	 <li id="mode"><xsl:value-of select="mode"/></li>
	 <li id="type"><xsl:value-of select="type"/></li>
	 <li id="color"><xsl:value-of select="color"/></li>
	 <li id="size"><xsl:value-of select="size"/></li>
	</ol>
     </xsl:for-each>
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="defaulttracestyle">
       [code]
       NewDataFolder/O/S root:Packages:SpXZeigR:Graphs:TraceStyles
       [/code]
	<DIV id="string">
	<p id="defaultTraceStyle"><xsl:value-of select="."/></p>
	</DIV>
</xsl:template>

</xsl:stylesheet>
